using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp11
{
    internal class Program
    {
        static void Main(string[] args)
        {
            long n, q, ukupnoPlazme = 0;
            string[] ulaz = Console.ReadLine().Split(' ');
            n = long.Parse(ulaz[0]);
            q = long.Parse(ulaz[1]);
            long[] d = new long[n];
            long[] p = new long[n];
            long[] k = new long[q];
            long[] izlazi = new long[q];
            for (int i = 0; i < n; i++)
            {
                ulaz = Console.ReadLine().Split(' ');
                d[i] = long.Parse(ulaz[0]);
                p[i] = long.Parse(ulaz[1]);

            }
            for (int j = 0; j < q; j++)
            {
                k[j] = long.Parse(Console.ReadLine());
                ukupnoPlazme = 0;
                if (k[j] < d[0])
                {
                    izlazi[j] = 0;
                }
                else
                {
                    for (long i = d[0];  i < k[j] + 1; i++)
                    {
                        
                        for(int g = 0; g < n; g++)
                        {
                            if(i == d[g])
                            {
                                ukupnoPlazme += p[g];
                            }
                        }
                        if(ukupnoPlazme != 0)
                        {
                            ukupnoPlazme--;
                            izlazi[j]++;
                        }
                        if (i == d[n - 1])
                        {
                            if(k[j] - i > ukupnoPlazme)
                            {
                                izlazi[j] += ukupnoPlazme;
                            }
                            else
                            {
                                izlazi[j] += k[j] - i;
                            }
                            break;
                        }
                    }
                }
            }
           
            for (int i = 0;i < izlazi.Length; i++)
            {
                Console.WriteLine(izlazi[i]);
            }
       
        }
    }
}